package com.hezongjian;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.RectF;

public class ColorRender implements IGameRender {

	
	// color kind
	private int[] 		cKind;
	private GameCore 	core;
	
	public ColorRender() {
		
		this.core = GameCore.getInstance();
		
		cKind = new int[core.getKind() + 1];
		cKind[0] = Color.BLACK;
		cKind[1] = Color.RED;
		cKind[2] = Color.BLUE;
		cKind[3] = Color.GREEN;
		cKind[4] = Color.CYAN;
		cKind[5] = Color.YELLOW;
		cKind[6] = Color.WHITE;
		cKind[7] = Color.MAGENTA;
        cKind[8] = Color.LTGRAY;
        cKind[9] = Color.DKGRAY;
        cKind[10] = Color.GRAY;
	}

	
	
	public void Render(Canvas c) {
		
		Paint p = new Paint();

		int w = c.getWidth();
		int h = c.getHeight();

		int elemW = w / core.getColCount();
		int elemH = h / core.getRowCount();

		for (int i = 1; i <= core.getRowCount(); i++) {
			for (int j = 1; j <= core.getColCount(); j++) {
                if (core.getGrid()[i][j] == 0)	// needn't draw
                    continue;

				p.setColor(cKind[core.getGrid()[i][j]]);
				//Rect rc = new Rect(elemW * (i - 1), elemH * (j - 1), elemW * i, elemH * j);
                Rect rc = new Rect(elemW * (j - 1), elemH * (i - 1), elemW * j, elemH * i);
				c.drawRect(rc, p);
			}
		}

		// draw current selection
		if (core.getCurSel() != null) {
			p.setColor(Color.BLACK);
			//Rect rc = new Rect(elemW * (core.getCurSel().x - 1), elemH * (core.getCurSel().y - 1), elemW
			//		* core.getCurSel().x, elemH * core.getCurSel().y);
            Rect rc = new Rect(elemW * (core.getCurSel().y - 1), elemH * (core.getCurSel().x - 1), elemW
                    * core.getCurSel().y, elemH * core.getCurSel().x);
 			c.drawOval(new RectF(rc), p);
		}

	}



	public void Notify(int notifyType, Object pData) {
		// TODO Auto-generated method stub
		
	}

}
