package com.hezongjian;

import android.app.Activity;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.Bundle;
import android.util.Log;
import android.view.*;
import android.widget.Toast;
import android.hardware.*;

public class MainActivity extends Activity{
	
	private android.hardware.SensorManager sensorMgr;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        sensorMgr = (SensorManager) this.getSystemService(SENSOR_SERVICE);
        
        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        		WindowManager.LayoutParams.FLAG_FULLSCREEN);
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        setContentView(R.layout.main);
        
        // test the swap function
        //this.testRotate();
    }
    
    private void testRotate()
    {
    	GameCore core = GameCore.getInstance();
    	Log.v("LLL", "Before rotate");
    	core.printGrid();
    	core.setOrientation(0);
    	Log.v("LLL", "After rotate");
    	core.printGrid();
    }

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		
		this.getMenuInflater().inflate(R.menu.main, menu);
		
		return true;
	}

        @Override
        public boolean onOptionsItemSelected(MenuItem item) {

            switch(item.getItemId())
            {
            case R.id.exit:
                {
                Intent it = new Intent();
                it.setClass(this, SettingActivity.class);
                this.startActivity(it);
                }
                break;
            case R.id.setting:
                {
                // invoke the setting activity
                Intent it = new Intent();
                it.setClass(this, SettingActivity.class);
                this.startActivity(it);
                }
                break;
            /*
            case R.id.test:
                {
                    Intent it  = new Intent(this, PhotoEnumActivity.class);
                    this.startActivity(it);
                }
                break;
                */
            case R.id.newgame:
                GameCore.getInstance().restart();
                this.findViewById(R.id.GameView).invalidate();
                Toast.makeText(this.getApplicationContext(), "New Game Started", Toast.LENGTH_SHORT).show();
                break;
            }

            return true;
        }

	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}

	@Override
	protected void onStop() {
		super.onStop();
		
		this.sensorMgr.unregisterListener((GameView)this.findViewById(R.id.GameView));
	}

	@Override
	protected void onResume() {
		super.onResume();

		// this.sensorMgr.registerListener(listener, sensors, rate)
		this.sensorMgr.registerListener((GameView) this
				.findViewById(R.id.GameView), sensorMgr
				.getDefaultSensor(Sensor.TYPE_ACCELEROMETER),
				SensorManager.SENSOR_DELAY_NORMAL);
	}

}